/**
   This program reads lines from standard input and
   echos them to standard output.

   When using Windows, if standard input is the console
   keyboard, use ^z (Control-z) to denote the end of file
   (and you must use ^z at the beginning of a line!).
*/
import java.util.Scanner;

public class Echo
{
   public static void main(String[] args)
   {
      // Create a Scanner object to make it easier to use System.in
      Scanner scanner = new Scanner( System.in );

      while ( scanner.hasNextLine() )
      {
         String oneLine = scanner.nextLine();
         System.out.println( oneLine );
      }
   }
}
