/**
   http://bugs.java.com/view_bug.do?bug_id=8023130

   On Windows, run the compiled program with the tested jdk's java

   \pathtojdk\bin\java InheritIO fc

   if you see the following:
   ----------------------
   FC: Insufficient number of file specifications
   Exit value: -1
   ----------------------
   then the test passed

   if you only see the line with the exit value:
   ----------------------
   Exit value: -1
   ----------------------
   then the test failed
*/

class InheritIO {
    public static void main(String[] args) throws Exception {
        int err = new ProcessBuilder(args).inheritIO().start().waitFor();
        System.err.println("Exit value: " + err);
    }
}
