// ReadWriteClipboardDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReadWriteClipboard.h"
#include "ReadWriteClipboardDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadWriteClipboardDlg dialog

CReadWriteClipboardDlg::CReadWriteClipboardDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReadWriteClipboardDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReadWriteClipboardDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReadWriteClipboardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadWriteClipboardDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReadWriteClipboardDlg, CDialog)
	//{{AFX_MSG_MAP(CReadWriteClipboardDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COPY_METAFILE, OnCopyMetafile)
	ON_BN_CLICKED(IDC_PASTE_METAFILE, OnPasteMetafile)
	ON_BN_CLICKED(IDC_COPY_BITMAP, OnCopyBitmap)
	ON_BN_CLICKED(IDC_PASTE_BITMAP, OnPasteBitmap)
	ON_BN_CLICKED(IDC_COPY_TEXT, OnCopyText)
	ON_BN_CLICKED(IDC_PASTE_TEXT, OnPasteText)
	ON_BN_CLICKED(IDC_COPY_CUSTOM, OnCopyCustom)
	ON_BN_CLICKED(IDC_PASTE_CUSTOM_FORMAT, OnPasteCustomFormat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadWriteClipboardDlg message handlers

BOOL CReadWriteClipboardDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
		
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CReadWriteClipboardDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReadWriteClipboardDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReadWriteClipboardDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CReadWriteClipboardDlg::DrawImage(CDC * pDC, CString pText) 
{
	CRect clip(0,0,200,200);
	pDC->FillSolidRect(clip,RGB(170,170,222));
	CPen pen;
	pen.CreatePen(PS_SOLID, 3, RGB(255,10,10));
	CPen * oldpen = pDC->SelectObject(&pen);
	pDC->MoveTo(0,0);
	pDC->LineTo(clip.right,clip.bottom);
	pDC->MoveTo(clip.right,clip.top);
	pDC->LineTo(0,clip.bottom);
	pDC->SelectObject(oldpen);
	pen.DeleteObject();
	pDC->TextOut(10,10,pText);
	pDC->TextOut(30,80,pText);
	pDC->TextOut(50,150,pText);
}

void CReadWriteClipboardDlg::OnCopyMetafile() 
{
	if ( OpenClipboard() )
	{
		EmptyClipboard();

		//create the metafile DC
		CMetaFileDC * cDC = new CMetaFileDC();
		cDC->CreateEnhanced(GetDC(),NULL,NULL,"the_name");

		//call draw routine here that makes GDI calls int cDC
		DrawImage(cDC,CString("Metafile"));

		//close meta CMetafileDC and get its handle
		HENHMETAFILE handle = cDC->CloseEnhanced();

		//place it on the clipboard
		SetClipboardData(CF_ENHMETAFILE,handle);
		CloseClipboard();

		//delete the dc
		delete cDC;
	}
	MessageBox("Metafile written to clipboard","WMF",MB_OK);
}

void CReadWriteClipboardDlg::OnPasteMetafile() 
{
	if ( OpenClipboard() )
	{

		//Get the clipboard data
		HENHMETAFILE handle = (HENHMETAFILE)GetClipboardData(CF_ENHMETAFILE);

		CClientDC dc(this);
		CRect client(0,0,200,200);
		dc.PlayMetaFile(handle,client);		

		CloseClipboard();

	}
}

void CReadWriteClipboardDlg::OnCopyBitmap() 
{
	if ( OpenClipboard() )
	{
		EmptyClipboard();
		//create some data
		CBitmap * junk = new CBitmap();
		CClientDC cdc(this);
		CDC dc;
		dc.CreateCompatibleDC(&cdc);
		CRect client(0,0,200,200);
		junk->CreateCompatibleBitmap(&cdc,client.Width(),client.Height());
		dc.SelectObject(junk);

		//call draw routine here that makes GDI calls
		DrawImage(&dc,CString("Bitmap"));

		//put the data on the clipboard
		SetClipboardData(CF_BITMAP,junk->m_hObject);
		CloseClipboard();

		//copy has been made on clipboard so we can delete
		delete junk;
	}
	MessageBox("Bitmap written to clipboard","BITMAP",MB_OK);
}

void CReadWriteClipboardDlg::OnPasteBitmap() 
{
	if ( OpenClipboard() )
	{

		//Get the clipboard data
		HBITMAP handle = (HBITMAP)GetClipboardData(CF_BITMAP);
		CBitmap * bm = CBitmap::FromHandle(handle);

		CClientDC cdc(this);
		CDC dc;
		dc.CreateCompatibleDC(&cdc);
		dc.SelectObject(bm);
		cdc.BitBlt(0,0,200,200,&dc,0,0,SRCCOPY);

		CloseClipboard();

	}
}

void CReadWriteClipboardDlg::OnCopyText() 
{
	CString source = "This is a sample for the clipboard!"; 
	//put your text in source
	if(OpenClipboard())
	{
		HGLOBAL clipbuffer;
		char * buffer;
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, source.GetLength()+1);
		buffer = (char*)GlobalLock(clipbuffer);
		strcpy(buffer, LPCSTR(source));
		GlobalUnlock(clipbuffer);
		SetClipboardData(CF_TEXT,clipbuffer);
		CloseClipboard();
	}
	MessageBox("Text written to clipboard","TEXT",MB_OK);
}

void CReadWriteClipboardDlg::OnPasteText() 
{
	CString fromClipboard;
	if ( OpenClipboard() ) 
	{
		HANDLE hData = GetClipboardData( CF_TEXT );
		char * buffer = (char*)GlobalLock( hData );
		fromClipboard = buffer;
		GlobalUnlock( hData );
		CloseClipboard();
	}
	MessageBox(fromClipboard,"READ TEXT",MB_OK);
}

struct MyFormatData
{
	long val1;
	int val2;
};

void CReadWriteClipboardDlg::OnCopyCustom() 
{
	UINT format = RegisterClipboardFormat("MY_CUSTOM_FORMAT");
	if(OpenClipboard())
	{
		//make some dummy data
		MyFormatData data;
		data.val1 = 100;
		data.val2 = 200;

		//allocate some global memory
		HGLOBAL clipbuffer;
		EmptyClipboard();
		clipbuffer = GlobalAlloc(GMEM_DDESHARE, sizeof(MyFormatData));
		MyFormatData * buffer = (MyFormatData*)GlobalLock(clipbuffer);

		//put the data into that memory
		*buffer = data;

		//[ut it on the clipboard
		GlobalUnlock(clipbuffer);
		SetClipboardData(format,clipbuffer);
		CloseClipboard();
	}
	MessageBox("Custom written to clipboard","CUSTOM",MB_OK);
}

void CReadWriteClipboardDlg::OnPasteCustomFormat() 
{
	//second call with just get format already registered
	UINT format = RegisterClipboardFormat("MY_CUSTOM_FORMAT");
	MyFormatData data;
	if ( OpenClipboard() ) 
	{
		//get the buffer
		HANDLE hData = GetClipboardData(format);
		MyFormatData * buffer = (MyFormatData *)GlobalLock( hData );

		//make a local copy
		data = *buffer;

		GlobalUnlock( hData );
		CloseClipboard();
	}
	CString fromClipboard;
	fromClipboard.Format("Value 1: %ld     Value 2 : %d",
		data.val1, data.val2);
	MessageBox(fromClipboard,"READ CUSTOM",MB_OK);
}
